(function () {  
	// You can check the number of bytes that have been  
	// queued but not yet transmitted to the server,  
	// this is very useful if the client application transports  
	// large amounts of data to the server.
	var MAX_BUFFER = 8192;  

	// ---------------------------------
	// Warning! NEVER USE WEBSOCKET 12345!
	// port 12345 is a known virus;  
	// Read Phaser Multi-Player Gaming Systems
	// Chapter 6.2 WebSocket Protocol HandShake page 159 & 170
	// ---------------------------------
	// new WebSocket (url, optional sub-protocol)  
	var ws = new WebSocket('ws://localhost:12345', 'echo-protocol');  

    //============================  
    // 4 WebSocket Protocol Msg  
    //============================  
	// WebSocket Events:  
	// you simply add callback functions to the WebSocket object  
	// or you can use the addEventListener() DOM method on your  
	// WebSocket objects. It’s important to implement these events  
	//  before attempting to send a message. 
	// ---------------------------------

	// FIN finished and cleaning up connection.  
	ws.onclose = function (event) {  
		console.log('Connection closed.');  
	}  
	
	// Oops! Discovered an error the TCP/IP  
	//  overlooked RTT or RTO problems  
	ws.onerror = function (event) {  
		console.log('An error occurred. Sorry for that.');  
	}  

	// Conversations / dialogs messages to and from  
	// alternate method:
	// ws.onmessage = incomingMsg(event);
	ws.onmessage = function (event) {  
		console.log('Response from server: ' + event.data);  
	}  

	// Successfully opened a WebSocket connection  
	ws.onopen = function (event) {  
		console.log('Connection opened.');  

		// let's try to send every second  
		setInterval( function() {  
			if (ws.bufferedAmount < MAX_BUFFER) {  
				ws.send(checkTheStatusAndSendData());  
			}  
		}, 1000);
	}  

	// Add our customized handling  
	// The readyState attribute may have one of the four values:  
	// - CONNECTING (The connection is not yet open)  
	// - OPEN (The connection is open and ready to communicate)  
	// - CLOSING (The connection is in the process of closing)  
	// - CLOSED (the connection is closed or couldn’t be opened)  
	// Knowing the current state can be very useful in  
	// troubleshooting your application.  
	ws.sendMessage = function (message) {  
		if(ws.readyState === ws.OPEN){  
			this.send(message);  
			console.log('Message sent: ' + message);  
		} else {  
			console.log('Connection failed.')  
		} 

	}  

	// Attach text created into a message  
	document.getElementById('send').addEventListener('click',  
	function (event) {  
		event.preventDefault();  
		var message = document.getElementById('message').value;  
		ws.sendMessage(message);  
	});  

})();  
